// TPI Extra header file for plug-ins.
// $Id: plugin-extra.h,v 1.1 2006/07/14 13:57:25 sirakaba Exp $

/*******************************************************************************
Copyright (c) 2002-2006 Silky.

This software is provided 'as-is', without any express or implied warranty. In  
no event will the authors be held liable for any damages arising from the use of
this software.

Permission is granted to anyone to use this software for any purpose, including 
commercial applications, and to alter it and redistribute it freely, subject to 
the following restrictions:

  1. The origin of this software must not be misrepresented; you must not claim 
     that you wrote the original software. If you use this software in a product,
     an acknowledgment in the product documentation would be appreciated but is 
     not required.
  2. Altered source versions must be plainly marked as such, and must not be mis-
     represented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
*******************************************************************************/

#ifndef __TPI_API_SPEC_EXTRA
#define __TPI_API_SPEC_EXTRA

//******************************************************************************
//    Defines
//******************************************************************************

//
// Extra Error Codes
//
#define TPI_ERROR_IO_MISC_MISC      TPI_ERROR_IO_MISC + TPI_ERROR_T_IO_MISC
#define TPI_ERROR_IO_MISC_NOTFOUND  TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_MISC_ACCESS    TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_MISC_OPEN      TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_MISC_CLOSE     TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_MISC_READ      TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_MISC_WRITE     TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_MISC_GETINFO   TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_MISC_POINT     TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_MISC_COPY      TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_MISC_MOVE      TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_MISC_DELETE    TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_MISC_SETINFO   TPI_ERROR_IO_MISC_MISC + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_ARC_MISC       TPI_ERROR_IO_MISC + TPI_ERROR_T_IO_ARCHIVE
#define TPI_ERROR_IO_ARC_NOTFOUND   TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_ARC_ACCESS     TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_ARC_OPEN       TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_ARC_CLOSE      TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_ARC_READ       TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_ARC_WRITE      TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_ARC_GETINFO    TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_ARC_POINT      TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_ARC_COPY       TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_ARC_MOVE       TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_ARC_DELETE     TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_ARC_SETINFO    TPI_ERROR_IO_ARC_MISC + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_FILE_MISC      TPI_ERROR_IO_MISC + TPI_ERROR_T_IO_FILE
#define TPI_ERROR_IO_FILE_NOTFOUND  TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_FILE_ACCESS    TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_FILE_OPEN      TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_FILE_CLOSE     TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_FILE_READ      TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_FILE_WRITE     TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_FILE_GETINFO   TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_FILE_POINT     TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_FILE_COPY      TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_FILE_MOVE      TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_FILE_DELETE    TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_FILE_SETINFO   TPI_ERROR_IO_FILE_MISC + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_TMP_MISC       TPI_ERROR_IO_MISC + TPI_ERROR_T_IO_WORKING
#define TPI_ERROR_IO_TMP_NOTFOUND   TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_TMP_ACCESS     TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_TMP_OPEN       TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_TMP_CLOSE      TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_TMP_READ       TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_TMP_WRITE      TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_TMP_GETINFO    TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_TMP_POINT      TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_TMP_COPY       TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_TMP_MOVE       TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_TMP_DELETE     TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_TMP_SETINFO    TPI_ERROR_IO_TMP_MISC + TPI_ERROR_IO_SETINFO

#define TPI_ERROR_IO_DIR_MISC       TPI_ERROR_IO_MISC + TPI_ERROR_T_IO_DIRECTORY
#define TPI_ERROR_IO_DIR_NOTFOUND   TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_NOTFOUND
#define TPI_ERROR_IO_DIR_ACCESS     TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_ACCESS
#define TPI_ERROR_IO_DIR_OPEN       TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_OPEN
#define TPI_ERROR_IO_DIR_CLOSE      TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_CLOSE
#define TPI_ERROR_IO_DIR_READ       TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_READ
#define TPI_ERROR_IO_DIR_WRITE      TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_WRITE
#define TPI_ERROR_IO_DIR_GETINFO    TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_GETINFO
#define TPI_ERROR_IO_DIR_POINT      TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_POINT
#define TPI_ERROR_IO_DIR_COPY       TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_COPY
#define TPI_ERROR_IO_DIR_MOVE       TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_MOVE
#define TPI_ERROR_IO_DIR_DELETE     TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_DELETE
#define TPI_ERROR_IO_DIR_SETINFO    TPI_ERROR_IO_DIR_MISC + TPI_ERROR_IO_SETINFO

#endif /* __TPI_API_SPEC_EXTRA */
